// Реле подлкючен к 0 пину и к +3.3v инверсия!!!
// Датчик температуры DHT11 к 2 пину

#include <ESP8266WiFi.h>
#include <PubSubClient.h>
#include <DHT.h>

#define DHTPIN 2
#define DHTTYPE DHT22

DHT dht(DHTPIN, DHTTYPE);

const char *ssid =  "Network";  // Имя вайфай точки доступа
const char *pass =  "11111111"; // Пароль от точки доступа

const char *mqtt_server = "192.168.1.12"; // Имя сервера MQTT
const int mqtt_port = 1883; // Порт для подключения к серверу MQTT
const char *mqtt_user = ""; // Логи от сервер
const char *mqtt_pass = ""; // Пароль от сервера

#define BUFFER_SIZE 100

bool LedState = false;
int tm=300;
int tmvrem=300; // по умолчанию
int tm1=300;
int autom=1; //если 0 - то ручное, если 1 - то автоматическое
int hum_min = 45; //минимальная влажность
int hum_max = 65; //максимальная влажность
float temp=0;
float h,t;

// Функция получения данных от сервера
void callback(const MQTT::Publish& pub){
  Serial.print(pub.topic());   // выводим в сериал порт название топика
  Serial.print(" => ");
  Serial.print(pub.payload_string()); // выводим в сериал порт значение полученных данных
  
  String payload = pub.payload_string();
  
  if(String(pub.topic()) == "Relay_1");
    {
     int stled = payload.toInt(); // преобразуем полученные данные в тип integer
     digitalWrite(5,stled);  //  включаем или выключаем светодиод в зависимоти от полученных значений данных
     }
     
}

WiFiClient wclient;      
PubSubClient client(wclient, mqtt_server, mqtt_port);

void setup() {
  Serial.begin(115200);
  delay(10);
  Serial.println();
  Serial.println();
  pinMode(5, OUTPUT); // отмечаем, что порт будет ВЫХОДОМ
  dht.begin();        // запускаем библиотеку датчика
}

void loop() {
  TempHum(); // показания с датчиков
   delay(10);

  // подключаемся к wi-fi
  if (WiFi.status() != WL_CONNECTED) {
    Serial.print("Connecting to ");
    Serial.print(ssid);
    Serial.println("...");
    WiFi.begin(ssid, pass);

    if (WiFi.waitForConnectResult() != WL_CONNECTED)
      return;
    Serial.println("WiFi connected");
  }

  // подключаемся к MQTT серверу
  if (WiFi.status() == WL_CONNECTED) {
    if (!client.connected()) {
      Serial.println("Connecting to MQTT server");
      if (client.connect(MQTT::Connect("arduinoClient2")
                         .set_auth(mqtt_user, mqtt_pass))) {
        Serial.println("MQTT server connected");
        client.set_callback(callback);
        client.subscribe("Relay_1"); // подписывааемся по топик с данными для управления реле
        //client.subscribe("test/aut1"); // подписывааемся на другие топики
        //client.subscribe("test/hmin1");
      } else {
        Serial.println("Could not connect to MQTT server");   
      }
    }

    if (client.connected()){ // если есть соединение
      client.loop();
      TempSend(); // Функция отправки показаний с термодатчика
     }
  
}
} // конец основного цикла

// Функция отправки показаний с термодатчика
void TempSend(){
  if (tm==0)
  {
   h = dht.readHumidity();
   t = dht.readTemperature();
   // Read temperature as Celsius (the default)


  client.publish("DHT22", String(t)+String(h));
  Serial.println(t);
  Serial.println(h);


  //client.publish("DHT22_t",String(t)); // отправляем в топик для термодатчика значение температуры
  //Serial.println((t));
  //client.publish("DHT22_rh",String(h)); // отправляем в топик для термодатчика значение влажности
  //Serial.println(h);

  tm = tmvrem;  // пауза меду отправками значений 
  }
  tm--; 
  delay(50);  
}
// чтение данных с датчика, раз в 3с.
void TempHum(){
   if (tm1==0)
  {
     h = dht.readHumidity();
     t = dht.readTemperature();
     tm1 = 300;
  }
   tm1--; 
  delay(10);
}


