#!/usr/bin/env python3
# -*- coding:utf-8 -*-
import webiopi							
import datetime
import json
import sys
import time
import os
import subprocess
import re

from subprocess import call
from time import strftime	

count = 44

#import context  # Ensures paho is in PYTHONPATH
import paho.mqtt.client as mqtt
import paho.mqtt.publish as publish

def on_connect(client, userdata, flags, rc):
    print("Connected with result code "+str(rc))

    # Subscribing in on_connect() means that if we lose the connection and
    # reconnect then subscriptions will be renewed.
    client.subscribe("DHT22/#")
    #client.subscribe("#", 0)	


# The callback for when a PUBLISH message is received from the server.
def on_message(client, userdata, msg):
    global data_dht, data_t, data_rh, count
    print(msg.topic+" "+str(msg.payload))
    data_dht = str(msg.payload)
    data_t = data_dht[2:6]
    data_rh = data_dht[7:11]
    count = count+1	
    if count > 43:		# 43 cikl*21sec = 900 sec
        data_entry = "{0},{1},{2}\n".format(strftime("%Y-%m-%d %H:%M:%S"), data_t, data_rh)
        f = open('/home/pi/myproject/html/logs/mqtt_dht22.txt', 'a')
        f.write(data_entry)
        f.close()	
        count = 0


client = mqtt.Client()
client.on_connect = on_connect
client.on_message = on_message
client.connect("192.168.1.12", 1883, 60)


client.loop_start()

#############################################################################################		

@webiopi.macro	
def getMqtt():
    e0 = data_t
    e1 = data_rh	
    lista = e0,e1   	
    print("lista",lista)	
    return json.dumps (lista)    
    #return data_t 
    #return data_rh

	
#############################################################################################		
################## УПРАВЛЕНИЕ РЕЛЕ В ESP8266 ################################################
#############################################################################################

# Включить		
@webiopi.macro	
def getEsp_ch1_on():
    publish.single("Relay_1","1",hostname="192.168.1.12")

	
# Отключить
@webiopi.macro	
def getEsp_ch1_off():
    publish.single("Relay_1","0",hostname="192.168.1.12")
	
	
	
#############################################################################################	
@webiopi.macro	
def clear_dht22_tabl():
    f = open('/home/pi/myproject/html/logs/mqtt_dht22.txt', 'w')	
    f.write('Date,Temperature,Humidity \n')		
    f.close()

